function HSAS:Init()
    self._menu = MenuUI:new({
		name = "HSASMenu",
		disable_player_controls = true,
		toggle_key = self.Options:GetValue("ToggleKey"),
		use_default_close_key = true,
        create_items = callback(self, self, "CreateItems"),
    })
end

Hooks:Add("MenuManagerInitialize", "HSAS", function()
	MenuCallbackHandler.HSAS = ClassClbk(HSAS._menu, "SetEnabled", true)
	local node = MenuHelperPlus:GetNode(nil, "blt_options")
	if node then
		MenuHelperPlus:AddButton({
			id = "HSAS",
			title = "HUD Scaling and Spacing",
			localized = false,
			node = node,
			callback = "HSAS",
		})
	end
end)


function HSAS:CreateItems(menu)
	local holder = menu:Menu({name = "holder", w = 300, auto_height = true, background_color = Color.black:with_alpha(0.5), position = "LeftCentery"})
	holder:KeyBind({name = "ToggleKey", value = self.Options:GetValue("ToggleKey"), text = "Toggle key", on_callback = ClassClbk(self, "Set")})
	holder:Slider({name = "Scale", min = 0.1, max = 1.5, value = HSAS.Options:GetValue("Scale"), on_callback = ClassClbk(self, "Set")})
	holder:Slider({name = "Spacing", min = 0.1, max = 1, value = HSAS.Options:GetValue("Spacing"), on_callback = ClassClbk(self, "Set")})
end

function HSAS:Set(item)
	HSAS.Options:SetValue(item:Name(), item:Value())
	if managers.hud and managers.hud.recreate_player_info_hud_pd2 then
		managers.gui_data:layout_scaled_fullscreen_workspace(managers.hud._saferect, HSAS.Options:GetValue("Scale"), HSAS.Options:GetValue("Spacing"))		
		managers.hud:recreate_player_info_hud_pd2()
	end
	self._menu.toggle_key = self.Options:GetValue("ToggleKey")
end