Hooks:PreHook(HUDManager, "_setup_player_info_hud_pd2", "HSASPreSetupPlayerInfoHudPD2", function(self)
    managers.gui_data:layout_scaled_fullscreen_workspace(self._saferect, HSAS.Options:GetValue("Scale"), HSAS.Options:GetValue("Spacing"))
end)

--Avoiding replacing these 2 big functions.
--I honestly have no clue if this may break but if it does, remove.
local add_waypoint = HUDManager.add_waypoint
function HUDManager:add_waypoint(...)
    local hud = self:script(PlayerBase.PLAYER_INFO_HUD_PD2)

    if not hud then
        return -- Gets called later again by the game
    end

    local orig_panel = hud.panel
    hud.panel = self._fullscreen_workspace:panel()
    local a,b,c = add_waypoint(self, ...)
    hud.panel = orig_panel

    return a,b,c
end

local update_waypoints = HUDManager._update_waypoints
function HUDManager:_update_waypoints(...)
    local orig_ws = self._saferect
    self._saferect = self._fullscreen_workspace
    local a,b,c = update_waypoints(self, ...)
    self._saferect = orig_ws

    return a,b,c
end

function HUDManager:remove_waypoint(id)
	self._hud.stored_waypoints[id] = nil

	if not self._hud.waypoints[id] then
		return
	end

    if not alive(self._hud.waypoints[id].bitmap) then
        return
    end

    local waypoint_panel = self._hud.waypoints[id].bitmap:parent()
    waypoint_panel:remove(self._hud.waypoints[id].bitmap)

    if alive(self._hud.waypoints[id].text) then
        waypoint_panel:remove(self._hud.waypoints[id].text)
    end

    if alive(self._hud.waypoints[id].arrow) then
        waypoint_panel:remove(self._hud.waypoints[id].arrow)
    end

	if alive(self._hud.waypoints[id].timer_gui) then
		waypoint_panel:remove(self._hud.waypoints[id].timer_gui)
	end

	if alive(self._hud.waypoints[id].distance) then
		waypoint_panel:remove(self._hud.waypoints[id].distance)
	end

	self._hud.waypoints[id] = nil
end


function HUDManager:recreate_player_info_hud_pd2()
    if not self:alive(PlayerBase.PLAYER_INFO_HUD_PD2) then return end
    local hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2)
    local full_hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_FULLSCREEN_PD2)

	--self:_create_teammates_panel(hud) --
    self:_create_present_panel(hud)
    self:_create_interaction(hud)
    self:_create_progress_timer(hud)
    --self:_create_objectives(hud)
    self:_create_hint(hud)
    self:_create_heist_timer(hud)
    self:_create_temp_hud(hud)
    self:_create_suspicion(hud)
    self:_create_hit_confirm(hud)
    self:_create_hit_direction(hud)
    self:_create_downed_hud()
    self:_create_custody_hud()
    self:_create_hud_chat() --
    self._hud_assault_corner = HUDAssaultCorner:new(hud, full_hud, tweak_data.levels[Global.game_settings.level_id].hud or {})
    self:_create_waiting_legend(hud)
    local mask = self:script(Idstring("guis/mask_off_hud"))
    if mask then
        local mask_on_text = mask.mask_on_text
        if alive(mask_on_text) then
            mask_on_text:set_world_center_x(hud.panel:world_center_x())
        end
    end
end

core:module("CoreGuiDataManager")
function GuiDataManager:layout_scaled_fullscreen_workspace(ws, scale, on_screen_scale)
    local base_res = {x = 1280, y = 720}
    local res = RenderSettings.resolution
    local sc = (2 - scale)
    local aspect_width = base_res.x / self:_aspect_ratio()
    local h = math.round(sc * math.max(base_res.y, aspect_width))
    local w = math.round(sc * math.max(base_res.x, aspect_width / h))

    local safe_w = math.round(on_screen_scale * res.x)
    local safe_h = math.round(on_screen_scale * res.y)   
    local sh = math.min(safe_h, safe_w / (w / h))
    local sw = math.min(safe_w, safe_h * (w / h))
    local x = res.x / 2 - sh * (w / h) / 2
    local y = res.y / 2 - sw / (w / h) / 2
    ws:set_screen(w, h, x, y, math.min(sw, sh * (w / h)))
end
